<?php
	//Open session
	session_start();
?>
<?php
	//Administrative check function (on a separate page)
	if(file_exists("../backend/securitycheck.php"))
	{
		include ("../backend/securitycheck.php");
	}
	else
	{
		die("Failed to open file \"../backend/securitycheck.php\" in read mode. It should now be microwaved.");
	}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
  <head>
    <meta http-equiv="content-type" content="text/html; charset=utf-8">
    <meta name="generator" content="CoffeeCup HTML Editor (www.coffeecup.com)">
    <meta name="created" content="Wed, 17 Jun 2015 12:33:52 GMT">
    <meta name="description" content="Listening to a live stream? Got a song you have to hear? This is the place to request it!">
	<link rel="shortcut icon" href="../backend/favicon.ico">
    <title> Music Request System-Upgrade System</title>
    
    <style type="text/css">
    <!--
    body {
      color:#000000;
	  background-color:#FFFFFF;
      background-image:url('../backend/background.gif');
      background-repeat:repeat;
    }
    a  { color:#FFFFFF; background-color:#0000FF; }
    a:visited { color:#FFFFFF; background-color:#800080; }
    a:hover { color:#000000; background-color:#00FF00; }
    a:active { color:#000000; background-color:#FF0000; }
    -->
    </style>
  </head>
  <body>
  <h1 style="text-align:center; text-decoration:underline;">MRS-Dry Upgrade Test Run</h1>
  <p>
  <?php
    /* Methodology
	Check if system has an existing ZIP file
	Check for stable switch
	Download appropriate package if necessary
	Verify new ZIP package
	Extract package
	Check the version of the latest downloaded file
	Enumerate extracted PHP files
	Make a copy of the existing about page
	Attempt to overwrite about page
	Return original about page
	Enumerate existing configuration files
	Enumerate new configuration files
	Attempt to write a new configuration file
	Make a copy of the posting file
	Attempt to overwrite posting file
	Return original posting file
	Delete all extracted files
	Delete downloaded archive*/
	$terminate=0;
	$downloaded=array(false,false);
    if(file_exists("../backend/logging.txt") && file_get_contents("../backend/logging.txt") == "yes")
    {
        $ip=$_SERVER['REMOTE_ADDR'];
		$fh=fopen("../log/" . date("Ymd") . ".txt",'a') or die("Failed to open file \"../log/" . date("Ymd") . ".txt\" in append mode. It should now be microwaved..");
		//Only show page if user is an administrator
		$date=date("g:i:s");
		fwrite($fh,$ip . " at " . $date . ": Attempted to begin system upgrade (dry run)\r\n");
        if(securitycheck() === false)
		{
			fclose($fh);
			die("You are not an administrator. <a href=\"../login.php\">Sign in</a> or <a href=\"../index.php\">Cancel</a>.");
		}
		//Check for an existing package
		echo ("Checking for an existing package...");
		$date=date("g:i:s");
		fwrite($fh,$ip . " at " . $date . ": Checking for existing package files\r\n");
		if(file_exists("latest.zip") && file_exists("latest-md5.txt"))
		{
			echo ("DONE.<br>\r\n");
		}
		else
		{
			echo ("FAILED. Either the package or the MD5 hash file doesn't exist.<br>\r\n");
		}
		//Check for stable switch file
		echo ("Checking to see which type of package the system should download...");
		$date=date("g:i:s");
		fwrite($fh,$ip . " at " . $date . ": Checking for upgrade switch\r\n");
		if(file_exists("../backend/stable.txt"))
		{
			echo ("DONE. ");
			if(file_get_contents("../backend/stable.txt") == "yes")
			{
				echo ("System is instructed to download only stable builds.<br>\r\n");
			}
			else
			{
				echo ("The system will download any new build if it is available.<br>\r\n");
			}
		}
		else
		{
			echo ("FAILED. Switch file does not exist. System will assume it can only download stable builds.<br>\r\n");
		}
		//Download ZIP (if needed)
		if(!file_exists("latest.zip"))
		{
			$downloaded[0]=true;
			echo ("Downloading upgrade package...");
			$date=date("g:i:s");
			fwrite($fh,$ip . " at " . $date . ": No local pack found, using CURL to get latest upgrade pack\r\n");
			//Open zip file
			$dfh=fopen("latest.zip",'w+');
			if($dfh)
			{
				//Initialize curl
				$curl=curl_init();
				$check=-1;
				if($curl !== false)
				{
					//Set curl options
					if(file_exists("../backend/stable.txt") && file_get_contents("../backend/stable.txt") == "yes")
					{
						curl_setopt($curl, CURLOPT_URL, "http://firealarms.redbat.ca/mrs/latest-stable.zip");
					}
					else
					{
						curl_setopt($curl, CURLOPT_URL, "http://firealarms.redbat.ca/mrs/latest.zip");
					}
					curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
					curl_setopt($curl, CURLOPT_BINARYTRANSFER, true);
					curl_setopt($curl, CURLOPT_FILE,$dfh);
					curl_setopt($curl, CURLOPT_HEADER, false);
					$date=date("g:i:s");
					fwrite($fh,$ip . " at " . $date . ": Set curl options\r\n");
					//Execute curl
					curl_exec($curl);
					$date=date("g:i:s");
					fwrite($fh,$ip . " at " . $date . ": Executed curl\r\n");
					
					//Check and form the data
					if(!curl_errno($curl) && curl_getinfo($curl,CURLINFO_HTTP_CODE) == 200)
					{
						$date=date("g:i:s");
						fwrite($fh,$ip . " at " . $date . ": Successfully executed curl\r\n");
						echo ("DONE.<br>\r\n");
					}
					else
					{
						//Curl failed
						$date=date("g:i:s");
						fwrite($fh,$ip . " at " . $date . ": Failed to execute curl, error: " . curl_errno($curl) . "\r\n");
						echo ("FAILED, error code " . curl_errno($curl) . ", HTTP response code " . curl_getinfo($curl,CURLINFO_HTTP_CODE) . ". Contact the software vendor and threaten to microwave their microphone.<br>\r\n");
						$cfail=true;
					}
					//Close session
					curl_close($curl);
					$date=date("g:i:s");
					fwrite($fh,$ip . " at " . $date . ": Closed curl session\r\n");
					fclose($dfh);
				}
			}
			else
			{
				//Cannot open the file for writing.
				$date=date("g:i:s");
				fwrite($fh,$ip . " at " . $date . ": Cannot open file\r\n");
				echo ("FAILED, unable to save file. Submerge the upgrade directory in pool water.<br>\r\n");
			}
		}
		//Delete leftover traces if curl failed and file didn't exist beforehand
		if(isset($cfail) && $cfail === true)
		{
			unlink("latest.zip");
		}
		//Verify that the file does exist
		$date=date("g:i:s");
		fwrite($fh,$ip . " at " . $date . ": Verifying upgrade file exists\r\n");
		echo ("Double-checking to make sure the required package exists...");
		if(file_exists("latest.zip"))
		{
			//Exists
			$date=date("g:i:s");
			fwrite($fh,$ip . " at " . $date . ": Verifying upgrade file exists\r\n");
			echo ("DONE.<br>\r\n");
		}
		else
		{
			//Doesn't exist
			$date=date("g:i:s");
			fwrite($fh,$ip . " at " . $date . ": Verifying upgrade file exists\r\n");
			echo ("FAILED. Either you had ONE JOB and didn't name the file correctly (it should be \"latest.zip\"), or the server needs to be microwaved.<br>\r\n");
			$terminate=1;
		}
		//Proceed after error handling
		if($terminate != 1)
		{
			//Verify MD5 sums
			echo ("Calculating MD5 hash of local ZIP archive...");
			$md5local=md5_file("latest.zip");
			echo ("DONE. MD5 hash: " . $md5local . "<br>\r\n");
			//Download MD5 hash from home server
			echo ("Downloading MD5 hash comparison file...");
			$md5remote=false;
			if(!file_exists("latest-md5.txt"))
			{
				$downloaded[1]=true;
				//Initialize curl
				$curl=curl_init();
				$check=-1;
				if($curl !== false)
				{
					$date=date("g:i:s");
					fwrite($fh,$ip . " at " . $date . ": Mo local file found, using CURL to get latest version MD5\r\n");
					//Set curl options
					if(file_exists("../backend/stable.txt") && file_get_contents("../backend/stable.txt") == "yes")
					{
						curl_setopt($curl, CURLOPT_URL, "http://firealarms.redbat.ca/mrs/latest-stable-md5.txt");
					}
					else
					{
						curl_setopt($curl, CURLOPT_URL, "http://firealarms.redbat.ca/mrs/latest-md5.txt");
					}
					curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
					curl_setopt($curl, CURLOPT_HEADER, false);
					$date=date("g:i:s");
					fwrite($fh,$ip . " at " . $date . ": Set curl options\r\n");
					//Execute curl
					$data = curl_exec($curl);
					$date=date("g:i:s");
					fwrite($fh,$ip . " at " . $date . ": Executed curl\r\n");
					
					//Check and form the data
					if($data != "" && !curl_errno($curl) && curl_getinfo($curl,CURLINFO_HTTP_CODE) == 200)
					{
						$date=date("g:i:s");
						fwrite($fh,$ip . " at " . $date . ": Successfully executed curl\r\n");
						$md5remote=$data;
						echo ("DONE. MD5 hash: " . $md5remote . "<br>\r\n");
					}
					else
					{
						//Curl failed
						$date=date("g:i:s");
						fwrite($fh,$ip . " at " . $date . ": Failed to execute curl, error: " . curl_errno($curl) . "\r\n");
						echo ("FAILED.<br>\r\n");
					}
					//Close session
					curl_close($curl);
					$date=date("g:i:s");
					fwrite($fh,$ip . " at " . $date . ": Closed curl session\r\n");
				}
			}
			else
			{
				//Local MD5 exists
				$date=date("g:i:s");
				fwrite($fh,$ip . " at " . $date . ": Getting latest version MD5 from local file\r\n");
				$md5remote=file_get_contents("latest-md5.txt");
				echo ("SKIPPED. Local file exists. MD5 hash: " . $md5remote . "<br>\r\n");
			}
			//Make sure MD5s match
			echo ("Checking MD5 hashes...");
			if($md5remote !== false && $md5remote != "" && $md5local == $md5remote)
			{
				$date=date("g:i:s");
				fwrite($fh,$ip . " at " . $date . ": Matched MD5 sums\r\n");
				echo ("DONE. Checksums matched, proceeding with upgrade.<br>\r\n");
			}
			elseif($md5remote == "" || $md5remote === false)
			{
				$date=date("g:i:s");
				fwrite($fh,$ip . " at " . $date . ": Remote MD5 blank, skipping check\r\n");
				echo ("SKIPPED. No MD5 to compare to. Proceeding with upgrade, expect problems.<br>\r\n");
			}
			else
			{
				$date=date("g:i:s");
				fwrite($fh,$ip . " at " . $date . ": MD5s do not match, aborting upgrade\r\n");
				echo("DONE. MD5s do NOT match, aborting upgrade process. Please re-download the MRS upgrade package, or contact the software vendor.<br>\r\n");
				$terminate=1;
			}
		}
		if($terminate != 1)
		{
			//Proceed with upgrade process
			//Create blank directory
			echo ("Creating temporary extraction directory...");
			$debug=mkdir("temp");
			if($debug === true)
			{
				$date=date("g:i:s");
				fwrite($fh,$ip . " at " . $date . ": created temporary extraction directory\r\n");
				echo ("DONE.<br>\r\n");
			}
			else
			{
				$date=date("g:i:s");
				fwrite($fh,$ip . " at " . $date . ": failed to create temporary extraction directory\r\n");
				echo("FAILED. Contact the software vendor.<br>\r\n");
				$terminate=1;
			}
		}
		if($terminate != 1)
		{
			//Proceed with upgrade process
			//Extract ZIP archive
			echo ("Extracting MRS files into temporary directory...");
			$arch=new ZipArchive;
			if($arch->open("latest.zip"))
			{
				$debug=$arch->extractTo("temp");
				if($debug === true)
				{
					$date=date("g:i:s");
					fwrite($fh,$ip . " at " . $date . ": extracted archive contents\r\n");
					echo ("DONE.<br>\r\n");
				}
				else
				{
					$date=date("g:i:s");
					fwrite($fh,$ip . " at " . $date . ": failed to extract\r\n");
					echo("FAILED. Could not extract archive. Please re-download the MRS upgrade package, or contact the software vendor.<br>\r\n");
					$terminate=1;
				}
				$arch->close();
			}
			else
			{
				$date=date("g:i:s");
				fwrite($fh,$ip . " at " . $date . ": failed to open archive\r\n");
				echo("FAILED. Could not open archive. Please re-download the MRS upgrade package, or contact the software vendor.<br>\r\n");
				$terminate=1;
			}
		}
		if($terminate != 1)
		{
			//Check system version
			$date=date("g:i:s");
			fwrite($fh,$ip . " at " . $date . ": checking downloaded version\r\n");
			echo ("Checking which version was downloaded...");
			if(file_exists("temp/version.txt"))
			{
				$version=explode("\r\n",file_get_contents("temp/version.txt"));
				$version[0]=explode("|",$version[0]);
				echo ("DONE. Downloaded version was " . $version[0][0] . "." . $version[0][1] . $version[1] . "." . $version[0][2] . ".<br>\r\n");
			}
			else
			{
				echo("FAILED. Please microwave something.<br>\r\n");
			}
			//Process additional directives
			echo ("Enumerating pre-core-replace upgrade directives...");
			$date=date("g:i:s");
			fwrite($fh,$ip . " at " . $date . ": checking for pre-core-replace upgrade directives\r\n");
			if(file_exists("temp/directives.txt"))
			{
				//Get contents of directives file and separate it by line
				$directives=explode("\r\n",file_get_contents("temp/directives.txt"));
				//Format each line (format: filename|destinationfolder/filename)
				for($i=0;$i<count($directives);$i++)
				{
					$directives[$i]=explode("|",$directives[$i]);
				}
			}
			else
			{
				$directives=array();
			}
			//Output number of directives to process
			echo ("DONE. There are " . count($directives) . " directives.<br>\r\n");
			//Enumerate PHP files to replace
			echo ("Enumerating core files to replace...");
			$files=glob("temp/*.php");
			for($i=0;$i<count($files);$i++)
			{
				//Make sure upgrade PHP files do not get moved!
				if(strpos($files[$i],"upgrade-") !== false)
				{
					unset($files[$i]);
				}
			}
			echo ("DONE. There are " . count($files) . " core files to replace.<br>\r\n");
			//Make a copy of the existing about page
			$copied=false;
			$date=date("g:i:s");
			fwrite($fh,$ip . " at " . $date . ": making a copy of the existing about page\r\n");
			echo ("Making a copy of an existing core PHP file...");
			$copied=copy("../about.php","about-backup.php");
			if($copied === true)
			{
				echo ("DONE.<br>\r\n");
				//Overwrite file with the one in the temp directory
				echo ("Testing core file replace...");
				$date=date("g:i:s");
				fwrite($fh,$ip . " at " . $date . ": overwriting existing about page with the new file\r\n");
				$debug=rename("temp/about.php","../about.php");
				if($debug === true)
				{
					echo ("DONE.<br>\r\n");
					//Put original file back
					echo ("Putting the original file back...");
					$date=date("g:i:s");
					fwrite($fh,$ip . " at " . $date . ": returning the existing file\r\n");
					$debug=rename("about-backup.php","../about.php");
					if($debug === true)
					{
						echo ("DONE.<br>\r\n");
					}
					else
					{
						echo ("FAILED. You will have to put the backup back yourself!<br>\r\n");
					}
				}
				else
				{
					echo ("FAILED.<br>\r\n");
					//Delete the backup as it isn't needed
					unlink("about-backup.php");
				}
			}
			else
			{
				echo ("FAILED. Skipping test overwrite test as it is unsafe to do so.<br>\r\n");
			}
			//Enumerate current config file base
			$date=date("g:i:s");
			fwrite($fh,$ip . " at " . $date . ": getting list of existing config files\r\n");
			//List of files NOT to remove
			$retain=array("firstuse","password","postid","version","baselist","songlist","rules","sysid");
			echo ("Enumerating config files...");
			$oldcfgs=array();
			$files=glob("../backend/*.txt");
			foreach($files as $file)
			{
				$file=substr($file,11,-4);
				if(!in_array($file,$retain))
				{
					$oldcfgs[]=$file;
				}
			}
			echo ("DONE.<br>\r\n");
			//Enumerate new config file base
			echo ("Enumerating system base configuration...");
			if(file_exists("temp/config.txt"))
			{
				$date=date("g:i:s");
				fwrite($fh,$ip . " at " . $date . ": getting list of new config files\r\n");
				$configs=explode("\r\n",file_get_contents("temp/config.txt"));
				$newcfg=array();
				foreach($configs as $config)
				{
					$config=explode("|",$config);
					$newcfg[]=$config[0];
				}
				echo ("DONE.<br>\r\n");
			}
			else
			{
				$date=date("g:i:s");
				fwrite($fh,$ip . " at " . $date . ": failed to get list of new config files\r\n");
				echo ("FAILED. Proceeding anyways, expect problems.<br>\r\n");
				$configs=array();
				$newcfg=array();
			}
			//Enumerate differences
			echo ("Determining differences between existing and new configs...");
			$date=date("g:i:s");
			fwrite($fh,$ip . " at " . $date . ": differencing config files\r\n");
			if(count($newcfg) > 0 && count($files) > 0)
			{
				$old=array_diff($oldcfgs,$newcfg);
				$new=array_diff($newcfg,$oldcfgs);
			}
			else
			{
				$old=array();
				$new=array();
			}
			echo ("DONE. " . count($old) . " obsolete files, " . count($new) . " new files.<br>\r\n");
			//Attempt to write a new configuration file
			$date=date("g:i:s");
			fwrite($fh,$ip . " at " . $date . ": making a new config file\r\n");
			echo ("Attempting to create new config file...");
			$debug=fopen("../backend/testconfigfile.txt",'w');
			if($debug)
			{
				fwrite($debug,"test!");
				fclose($debug);
				echo ("DONE.<br>\r\n");
				//Attempt to read file
				echo ("Reading the new config file...");
				if(file_exists("../backend/testconfigfile.txt"))
				{
					echo ("DONE. Contents: \"" . file_get_contents("../backend/testconfigfile.txt") . "\" (should be \"test!\")<br>\r\n");
				}
				else
				{
					echo ("FAILED. Please microwave something.<br>\r\n");
				}
				unlink("../backend/testconfigfile.txt");
			}
			else
			{
				echo ("FAILED. Please microwave something.<br>\r\n");
			}
			//Make a backup of existing posting switch
			$copied=false;
			$date=date("g:i:s");
			fwrite($fh,$ip . " at " . $date . ": making a copy of the existing posting config file\r\n");
			echo ("Making a copy of an existing config file...");
			$copied=copy("../backend/posting.txt","posting-backup.txt");
			if($copied === true)
			{
				echo ("DONE.<br>\r\n");
				//Overwrite file with the one in the temp directory
				echo ("Testing config file replace...");
				$date=date("g:i:s");
				fwrite($fh,$ip . " at " . $date . ": testing file overwriting capability\r\n");
				$debug=fopen("../backend/posting.txt",'w');
				if($debug)
				{
					echo ("DONE.<br>\r\n");
					fwrite($debug,"not");
					fclose($debug);
					echo ("Checking contents of newly-written file...");
					if(file_exists("../backend/posting.txt"))
					{
						echo ("DONE. Contents: \"" . file_get_contents("../backend/posting.txt") . "\" (should be \"not\")<br>\r\n");
					}
					else
					{
						echo ("FAILED. Please microwave something.<br>\r\n");
					}
					//Put original file back
					echo ("Returning original file...");
					$date=date("g:i:s");
					fwrite($fh,$ip . " at " . $date . ": returning the existing file\r\n");
					$debug=rename("posting-backup.txt","../backend/posting.txt");
					if($debug === true)
					{
						echo ("DONE.<br>\r\n");
					}
					else
					{
						echo ("FAILED. You will have to put the backup back yourself!<br>\r\n");
					}
				}
				else
				{
					echo ("FAILED.<br>\r\n");
					//Delete the backup as it isn't needed
					unlink("posting-backup.txt");
				}
			}
			else
			{
				echo ("FAILED. Skipping test overwrite test as it is unsafe to do so.<br>\r\n");
			}
			//Clean up
			$date=date("g:i:s");
			fwrite($fh,$ip . " at " . $date . ": removing temporary files\r\n");
			echo ("Removing all upgrade files...");
			$files=glob("temp/*");
			$error=0;
			if(count($files) > 0)
			{
				foreach($files as $file)
				{
					$debug=unlink($file);
					if($debug !== true)
					{
						$error++;
						$date=date("g:i:s");
						fwrite($fh,$ip . " at " . $date . ": failed to remove file \"$file\"\r\n");
					}
				}
			}
			echo ("DONE. $error errors.<br>\r\n");
			//Remove temporary directory
			$date=date("g:i:s");
			fwrite($fh,$ip . " at " . $date . ": removing temporary directory\r\n");
			echo ("Removing temporary directory...");
			$debug=rmdir("temp");
			if($debug === true)
			{
				echo ("DONE.<br>\r\n");
			}
			else
			{
				echo ("FAILED.<br>\r\n");
			}
			//Remove ZIP file
			echo ("Removing ZIP archive...");
			if($downloaded[0] === true)
			{
				$debug=unlink("latest.zip");
				if($debug === true)
				{
					echo ("DONE.<br>\r\n");
				}
				else
				{
					echo ("FAILED.<br>\r\n");
				}
			}
			else
			{
				echo ("SKIPPED.<br>\r\n");
			}
			//Remove MD5 file
			echo ("Removing MD5 hash...");
			if(file_exists("latest-md5.txt") && $downloaded[1] === true)
			{
				$debug=unlink("latest-md5.txt");
				if($debug === true)
				{
					echo ("DONE.<br>\r\n");
				}
				else
				{
					echo ("FAILED.<br>\r\n");
				}
			}
			else
			{
				echo ("SKIPPED.<br>\r\n");
			}
		}
        echo ("Upgrade process ended. Check output and/or logfiles for errors before leaving this page.<br>\r\n");
		fclose($fh);
	}
    else
    {
		//Only show page if user is an administrator
        if(securitycheck() === false)
		{
			die("You are not an administrator. <a href=\"../login.php\">Sign in</a> or <a href=\"../index.php\">Cancel</a>.");
		}
		//Check for an existing package
		echo ("Checking for an existing package...");
		if(file_exists("latest.zip") && file_exists("latest-md5.txt"))
		{
			echo ("DONE.<br>\r\n");
		}
		else
		{
			echo ("FAILED. Either the package or the MD5 hash file doesn't exist.<br>\r\n");
		}
		//Check for stable switch file
		echo ("Checking to see which type of package the system should download...");
		if(file_exists("../backend/stable.txt"))
		{
			echo ("DONE. ");
			if(file_get_contents("../backend/stable.txt") == "yes")
			{
				echo ("System is instructed to download only stable builds.<br>\r\n");
			}
			else
			{
				echo ("The system will download any new build if it is available.<br>\r\n");
			}
		}
		else
		{
			echo ("FAILED. Switch file does not exist. System will assume it can only download stable builds.<br>\r\n");
		}
		//Download ZIP (if needed)
		if(!file_exists("latest.zip"))
		{
			$downloaded[0]=true;
			echo ("Downloading upgrade package...");
			//Open zip file
			$dfh=fopen("latest.zip",'w+');
			if($dfh)
			{
				//Initialize curl
				$curl=curl_init();
				$check=-1;
				if($curl !== false)
				{
					//Set curl options
					if(file_exists("../backend/stable.txt") && file_get_contents("../backend/stable.txt") == "yes")
					{
						curl_setopt($curl, CURLOPT_URL, "http://firealarms.redbat.ca/mrs/latest-stable.zip");
					}
					else
					{
						curl_setopt($curl, CURLOPT_URL, "http://firealarms.redbat.ca/mrs/latest.zip");
					}
					curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
					curl_setopt($curl, CURLOPT_BINARYTRANSFER, true);
					curl_setopt($curl, CURLOPT_FILE,$dfh);
					curl_setopt($curl, CURLOPT_HEADER, false);
					//Execute curl
					curl_exec($curl);
					
					//Check and form the data
					if(!curl_errno($curl) && curl_getinfo($curl,CURLINFO_HTTP_CODE) == 200)
					{
						echo ("DONE.<br>\r\n");
					}
					else
					{
						//Curl failed
						echo ("FAILED, error code " . curl_errno($curl) . ", HTTP response code " . curl_getinfo($curl,CURLINFO_HTTP_CODE) . ". Contact the software vendor and threaten to microwave their microphone.<br>\r\n");
						$cfail=true;
					}
					//Close session
					curl_close($curl);
					fclose($dfh);
				}
			}
			else
			{
				//Cannot open the file for writing.
				echo ("FAILED, unable to save file. Submerge the upgrade directory in pool water.<br>\r\n");
			}
		}
		//Delete leftover traces if curl failed and file didn't exist beforehand
		if(isset($cfail) && $cfail === true)
		{
			unlink("latest.zip");
		}
		//Verify that the file does exist
		echo ("Double-checking to make sure the required package exists...");
		if(file_exists("latest.zip"))
		{
			//Exists
			echo ("DONE.<br>\r\n");
		}
		else
		{
			//Doesn't exist
			echo ("FAILED. Either you had ONE JOB and didn't name the file correctly (it should be \"latest.zip\"), or the server needs to be microwaved.<br>\r\n");
			$terminate=1;
		}
		//Proceed after error handling
		if($terminate != 1)
		{
			//Verify MD5 sums
			echo ("Calculating MD5 hash of local ZIP archive...");
			$md5local=md5_file("latest.zip");
			echo ("DONE. MD5 hash: " . $md5local . "<br>\r\n");
			//Download MD5 hash from home server
			echo ("Downloading MD5 hash comparison file...");
			$md5remote=false;
			if(!file_exists("latest-md5.txt"))
			{
				$downloaded[1]=true;
				//Initialize curl
				$curl=curl_init();
				$check=-1;
				if($curl !== false)
				{
					//Set curl options
					if(file_exists("../backend/stable.txt") && file_get_contents("../backend/stable.txt") == "yes")
					{
						curl_setopt($curl, CURLOPT_URL, "http://firealarms.redbat.ca/mrs/latest-stable-md5.txt");
					}
					else
					{
						curl_setopt($curl, CURLOPT_URL, "http://firealarms.redbat.ca/mrs/latest-md5.txt");
					}
					curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
					curl_setopt($curl, CURLOPT_HEADER, false);
					//Execute curl
					$data = curl_exec($curl);
					
					//Check and form the data
					if($data != "" && !curl_errno($curl) && curl_getinfo($curl,CURLINFO_HTTP_CODE) == 200)
					{
						$md5remote=$data;
						echo ("DONE. MD5 hash: " . $md5remote . "<br>\r\n");
					}
					else
					{
						//Curl failed
						echo ("FAILED.<br>\r\n");
					}
					//Close session
					curl_close($curl);
				}
			}
			else
			{
				//Local MD5 exists
				$md5remote=file_get_contents("latest-md5.txt");
				echo ("SKIPPED. Local file exists. MD5 hash: " . $md5remote . "<br>\r\n");
			}
			//Make sure MD5s match
			echo ("Checking MD5 hashes...");
			if($md5remote !== false && $md5remote != "" && $md5local == $md5remote)
			{
				echo ("DONE. Checksums matched, proceeding with upgrade.<br>\r\n");
			}
			elseif($md5remote == "" || $md5remote === false)
			{
				echo ("SKIPPED. No MD5 to compare to. Proceeding with upgrade, expect problems.<br>\r\n");
			}
			else
			{
				echo("DONE. MD5s do NOT match, aborting upgrade process. Please re-download the MRS upgrade package, or contact the software vendor.<br>\r\n");
				$terminate=1;
			}
		}
		if($terminate != 1)
		{
			//Proceed with upgrade process
			//Create blank directory
			echo ("Creating temporary extraction directory...");
			$debug=mkdir("temp");
			if($debug === true)
			{
				echo ("DONE.<br>\r\n");
			}
			else
			{
				echo("FAILED. Contact the software vendor.<br>\r\n");
				$terminate=1;
			}
		}
		if($terminate != 1)
		{
			//Proceed with upgrade process
			//Extract ZIP archive
			echo ("Extracting MRS files into temporary directory...");
			$arch=new ZipArchive;
			if($arch->open("latest.zip"))
			{
				$debug=$arch->extractTo("temp");
				if($debug === true)
				{
					echo ("DONE.<br>\r\n");
				}
				else
				{
					echo("FAILED. Could not extract archive. Please re-download the MRS upgrade package, or contact the software vendor.<br>\r\n");
					$terminate=1;
				}
				$arch->close();
			}
			else
			{
				echo("FAILED. Could not open archive. Please re-download the MRS upgrade package, or contact the software vendor.<br>\r\n");
				$terminate=1;
			}
		}
		if($terminate != 1)
		{
			//Check system version
			echo ("Checking which version was downloaded...");
			if(file_exists("temp/version.txt"))
			{
				$version=explode("\r\n",file_get_contents("temp/version.txt"));
				$version[0]=explode("|",$version[0]);
				echo ("DONE. Downloaded version was " . $version[0][0] . "." . $version[0][1] . $version[1] . "." . $version[0][2] . ".<br>\r\n");
			}
			else
			{
				echo("FAILED. Please microwave something.<br>\r\n");
			}
			//Process additional directives
			echo ("Enumerating pre-core-replace upgrade directives...");
			if(file_exists("temp/directives.txt"))
			{
				//Get contents of directives file and separate it by line
				$directives=explode("\r\n",file_get_contents("temp/directives.txt"));
				//Format each line (format: filename|destinationfolder/filename)
				for($i=0;$i<count($directives);$i++)
				{
					$directives[$i]=explode("|",$directives[$i]);
				}
			}
			else
			{
				$directives=array();
			}
			//Output number of directives to process
			echo ("DONE. There are " . count($directives) . " directives.<br>\r\n");
			//Enumerate PHP files to replace
			echo ("Enumerating core files to replace...");
			$files=glob("temp/*.php");
			for($i=0;$i<count($files);$i++)
			{
				//Make sure upgrade PHP files do not get moved!
				if(strpos($files[$i],"upgrade-") !== false)
				{
					unset($files[$i]);
				}
			}
			echo ("DONE. There are " . count($files) . " core files to replace.<br>\r\n");
			//Make a copy of the existing about page
			$copied=false;
			echo ("Making a copy of an existing core PHP file...");
			$copied=copy("../about.php","about-backup.php");
			if($copied === true)
			{
				echo ("DONE.<br>\r\n");
				//Overwrite file with the one in the temp directory
				echo ("Testing core file replace...");
				$debug=rename("temp/about.php","../about.php");
				if($debug === true)
				{
					echo ("DONE.<br>\r\n");
					//Put original file back
					echo ("Putting the original file back...");
					$debug=rename("about-backup.php","../about.php");
					if($debug === true)
					{
						echo ("DONE.<br>\r\n");
					}
					else
					{
						echo ("FAILED. You will have to put the backup back yourself!<br>\r\n");
					}
				}
				else
				{
					echo ("FAILED.<br>\r\n");
					//Delete the backup as it isn't needed
					unlink("about-backup.php");
				}
			}
			else
			{
				echo ("FAILED. Skipping test overwrite test as it is unsafe to do so.<br>\r\n");
			}
			//Enumerate current config file base
			//List of files NOT to remove
			$retain=array("firstuse","password","postid","version","baselist","songlist","rules","sysid");
			echo ("Enumerating config files...");
			$oldcfgs=array();
			$files=glob("../backend/*.txt");
			foreach($files as $file)
			{
				$file=substr($file,11,-4);
				if(!in_array($file,$retain))
				{
					$oldcfgs[]=$file;
				}
			}
			echo ("DONE.<br>\r\n");
			//Enumerate new config file base
			echo ("Enumerating system base configuration...");
			if(file_exists("temp/config.txt"))
			{
				$configs=explode("\r\n",file_get_contents("temp/config.txt"));
				$newcfg=array();
				foreach($configs as $config)
				{
					$config=explode("|",$config);
					$newcfg[]=$config[0];
				}
				echo ("DONE.<br>\r\n");
			}
			else
			{
				echo ("FAILED. Proceeding anyways, expect problems.<br>\r\n");
				$configs=array();
				$newcfg=array();
			}
			//Enumerate differences
			echo ("Determining differences between existing and new configs...");
			if(count($newcfg) > 0 && count($files) > 0)
			{
				$old=array_diff($oldcfgs,$newcfg);
				$new=array_diff($newcfg,$oldcfgs);
			}
			else
			{
				$old=array();
				$new=array();
			}
			echo ("DONE. " . count($old) . " obsolete files, " . count($new) . " new files.<br>\r\n");
			//Attempt to write a new configuration file
			echo ("Attempting to create new config file...");
			$debug=fopen("../backend/testconfigfile.txt",'w');
			if($debug)
			{
				fwrite($debug,"test!");
				fclose($debug);
				echo ("DONE.<br>\r\n");
				//Attempt to read file
				echo ("Reading the new config file...");
				if(file_exists("../backend/testconfigfile.txt"))
				{
					echo ("DONE. Contents: \"" . file_get_contents("../backend/testconfigfile.txt") . "\" (should be \"test!\")<br>\r\n");
				}
				else
				{
					echo ("FAILED. Please microwave something.<br>\r\n");
				}
				unlink("../backend/testconfigfile.txt");
			}
			else
			{
				echo ("FAILED. Please microwave something.<br>\r\n");
			}
			//Make a backup of existing posting switch
			$copied=false;
			echo ("Making a copy of an existing config file...");
			$copied=copy("../backend/posting.txt","posting-backup.txt");
			if($copied === true)
			{
				echo ("DONE.<br>\r\n");
				//Overwrite file with the one in the temp directory
				echo ("Testing config file replace...");
				$debug=fopen("../backend/posting.txt",'w');
				if($debug)
				{
					echo ("DONE.<br>\r\n");
					fwrite($debug,"not");
					fclose($debug);
					echo ("Checking contents of newly-written file...");
					if(file_exists("../backend/posting.txt"))
					{
						echo ("DONE. Contents: \"" . file_get_contents("../backend/posting.txt") . "\" (should be \"not\")<br>\r\n");
					}
					else
					{
						echo ("FAILED. Please microwave something.<br>\r\n");
					}
					//Put original file back
					echo ("Returning original file...");
					$debug=rename("posting-backup.txt","../backend/posting.txt");
					if($debug === true)
					{
						echo ("DONE.<br>\r\n");
					}
					else
					{
						echo ("FAILED. You will have to put the backup back yourself!<br>\r\n");
					}
				}
				else
				{
					echo ("FAILED.<br>\r\n");
					//Delete the backup as it isn't needed
					unlink("posting-backup.txt");
				}
			}
			else
			{
				echo ("FAILED. Skipping test overwrite test as it is unsafe to do so.<br>\r\n");
			}
			//Clean up
			echo ("Removing all upgrade files...");
			$files=glob("temp/*");
			$error=0;
			if(count($files) > 0)
			{
				foreach($files as $file)
				{
					$debug=unlink($file);
					if($debug !== true)
					{
						$error++;
						$date=date("g:i:s");
						fwrite($fh,$ip . " at " . $date . ": failed to remove file \"$file\"\r\n");
					}
				}
			}
			echo ("DONE. $error errors.<br>\r\n");
			//Remove temporary directory
			echo ("Removing temporary directory...");
			$debug=rmdir("temp");
			if($debug === true)
			{
				echo ("DONE.<br>\r\n");
			}
			else
			{
				echo ("FAILED.<br>\r\n");
			}
			//Remove ZIP file
			echo ("Removing ZIP archive...");
			if($downloaded[0] === true)
			{
				$debug=unlink("latest.zip");
				if($debug === true)
				{
					echo ("DONE.<br>\r\n");
				}
				else
				{
					echo ("FAILED.<br>\r\n");
				}
			}
			else
			{
				echo ("SKIPPED.<br>\r\n");
			}
			//Remove MD5 file
			echo ("Removing MD5 hash...");
			if(file_exists("latest-md5.txt") && $downloaded[1] === true)
			{
				$debug=unlink("latest-md5.txt");
				if($debug === true)
				{
					echo ("DONE.<br>\r\n");
				}
				else
				{
					echo ("FAILED.<br>\r\n");
				}
			}
			else
			{
				echo ("SKIPPED.<br>\r\n");
			}
		}
        echo ("Upgrade process ended. Check output and/or logfiles for errors before leaving this page.<br>\r\n");
    }
  ?>
  <a href="../index.php">Go home</a></p>
  </body>
</html>